
module.exports = function(grunt) {

    // Project configuration.
    grunt.initConfig({
        addgearsRun:{
            hello:{
                src:'examples/hello-world.js'                
            },
            main:{
                page:'pages/pricer/main.html'
            },
            origin:{
                page:'http-server.js@open-url.js',
                options:{
                    command: [
                    "-httpServerRoot", ".",
                    "-httpPort", 9876,                    
                    "-openUrl","http://localhost:9876/page.html?page=pages/pricer/main.html"
                    ]
                }                
            },              
            url:{
                page:'http-server.js@open-url.js',
                options:{
                    command: [
                    "-httpServerRoot", ".",
                    "-httpPort", 9876,                    
                    "-openUrl","http://localhost:9876/package.json"
                    ]
                }                
            }           
        },
        downloadUpdate:{
            main:{
                path:'update.zip'                
            }
        },
        unzip:{
            update: {
                src: ['update.zip'],
                dest: '.'
            }
        },        
        addgearsApplyUpdate:{
            main:{                
                src:["update"]                
            },
            origin:{
                options:{
                    updateOrigin:"http://localhost:9876"
                },
                src:["update"] 
            }
        }
    });


    grunt.loadNpmTasks('grunt-zip');
    grunt.loadTasks('tasks');
    
    grunt.registerTask('hello', ['addgearsRun:hello']);
    grunt.registerTask('main', ['addgearsRun:main']);
    grunt.registerTask('origin', ['addgearsRun:origin']);
    grunt.registerTask('url', ['addgearsRun:url']);

    grunt.registerTask('update', ['downloadUpdate', 'unzip', 'addgearsApplyUpdate:main']);
    grunt.registerTask('update-origin', ['addgearsApplyUpdate:origin']);
    grunt.registerTask('update-main', ['addgearsApplyUpdate:main']);

    // Default task(s).
    grunt.registerTask('default', ['install']);

};