var fs = require('fs');
var life = require('./life-cycle');
var logger = require('./logger').common;

var dest = life.destination;
var installerName = life.installerName;
var defaults = life.options();

var install = life.install;
var download = life.download;
var copyTo = life.copyTo;

function installer(options){
    options = copyTo(options, copyTo(defaults, {}));

    if(fs.existsSync(installerName)){
        logger.info("installer found, skipping download:" + installerName);
        install(installerName, dest, options.callback);
    }
    else{
        download(
            options.binary, 
            installerName, 
            function(){
                logger.info("download finished");
                install(installerName, dest, options.callback);
            }
        );
    }
}

if (require.main === module) {
    installer();
}
else{
    (module).exports = installer;
}
