var cycle = require('./life-cycle');

var Addgears = {
	lifeCycle:cycle,

	download:cycle.download,
	options:cycle.options,

	dataDir:function(){
		var path = require("path");
		return path.join(process.env.LOCALAPPDATA, "addgears");
	},	

	run:function(file, options){
		var copyTo = cycle.copyTo;
		options = copyTo(options, {});

		var command = [
			'-page',
			'js-scripts.js',
			'-js',
			file
		];
		
		command.push('--remote-debugging-port=9222');
		if(options.logging){
			command.push('--enable-logging');
		}
		options.command = command;

		return cycle.start(options);
	},

	page:function(name, options){
		var copyTo = cycle.copyTo;
		options = copyTo(options, {});

		var command = [
			'-page',
			name
		];

		if(options.command){
			command = command.concat(options.command);
		}
		
		command.push('--remote-debugging-port=9222');
		if(options.logging){
			command.push('--enable-logging');
		}
		options.command = command;

		return cycle.start(options);
	},

	update:function(options){
		var copyTo = cycle.copyTo;
		options = copyTo(options, {});
		
		var command = [
			'-install',
			"1"
		];

		if(!options.show){
			command.push("-hidden", "1");
		}

		if(options.update){
			command.push("-hidden", update);
		}

		if(options.updateOrigin){
			command.push("-updateOrigin", options.updateOrigin);
			command.push(
				"-page", "http-server.js@open-url.js",
		        "-httpServerRoot", ".",
                "-httpPort", options.updateOrigin.split(":")[2]
            );  
			command.push("-openUrl", options.updateOrigin + "/page.html");
		}
		
		
		command.push('--remote-debugging-port=9222');
		if(options.logging){
			command.push('--enable-logging');
		}
		options.command = command;

		return cycle.start(options);
	},	

	dest:function(path){
		if(!path){
			return cycle.destination;
		}
		return require('path').join(cycle.destination, path);
	}	
}

module.exports = Addgears;